/* DisplayWidget.c generated by valac 0.53.1, the Vala compiler
 * generated from DisplayWidget.vala, do not modify */

/*-
 * Copyright 2014–2021 elementary, Inc.
 *           2014–2018 Corentin Noël <corentin@elementary.io>
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "display.h"
#include <glib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <glib/gi18n-lib.h>
#include <gee.h>

enum  {
	DISPLAY_DISPLAY_WIDGET_0_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_NUM_PROPERTIES
};
static GParamSpec* display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_NUM_PROPERTIES];
typedef enum  {
	DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME,
	DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_MODE,
	DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_TOTAL
} DisplayDisplayWidgetResolutionColumns;

#define DISPLAY_DISPLAY_WIDGET_TYPE_RESOLUTION_COLUMNS (display_display_widget_resolution_columns_get_type ())
typedef enum  {
	DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME,
	DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE,
	DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_TOTAL
} DisplayDisplayWidgetRotationColumns;

#define DISPLAY_DISPLAY_WIDGET_TYPE_ROTATION_COLUMNS (display_display_widget_rotation_columns_get_type ())
typedef enum  {
	DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_NAME,
	DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_VALUE,
	DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_TOTAL
} DisplayDisplayWidgetRefreshColumns;

#define DISPLAY_DISPLAY_WIDGET_TYPE_REFRESH_COLUMNS (display_display_widget_refresh_columns_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
enum  {
	DISPLAY_DISPLAY_WIDGET_SET_AS_PRIMARY_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_MOVE_DISPLAY_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_END_GRAB_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_ACTIVE_CHANGED_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_NUM_SIGNALS
};
static guint display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_NUM_SIGNALS] = {0};

struct _DisplayDisplayWidgetPrivate {
	gint _delta_x;
	gint _delta_y;
	gboolean _only_display;
	gdouble start_x;
	gdouble start_y;
	gboolean holding;
	GtkButton* _primary_image;
	GtkMenuButton* _toggle_settings;
	GtkSwitch* use_switch;
	GtkComboBox* resolution_combobox;
	GtkListStore* resolution_list_store;
	GtkComboBox* rotation_combobox;
	GtkListStore* rotation_list_store;
	GtkComboBox* refresh_combobox;
	GtkListStore* refresh_list_store;
	gint real_width;
	gint real_height;
};

struct _Block4Data {
	int _ref_count_;
	DisplayDisplayWidget* self;
	gchar* virtual_monitor_name;
	GtkLabel* label;
	DisplayVirtualMonitor* virtual_monitor;
};

struct _Block5Data {
	int _ref_count_;
	DisplayDisplayWidget* self;
	DisplayMonitorMode* mode;
};

struct _Block6Data {
	int _ref_count_;
	DisplayDisplayWidget* self;
	DisplayTransform transform;
};

static gint DisplayDisplayWidget_private_offset;
static gpointer display_display_widget_parent_class = NULL;

static GType display_display_widget_resolution_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType display_display_widget_rotation_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType display_display_widget_refresh_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void display_display_widget_set_primary_image (DisplayDisplayWidget* self,
                                               GtkButton* value);
static void __lambda7_ (DisplayDisplayWidget* self);
static void ___lambda7__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static gboolean _display_resolution_equal (const DisplayResolution * s1,
                                    const DisplayResolution * s2);
static gboolean _vala_display_resolution_array_contains (DisplayResolution * stack,
                                                  gssize stack_length,
                                                  const DisplayResolution * needle);
static void _vala_array_add3 (DisplayResolution* * array,
                       gint* length,
                       gint* size,
                       const DisplayResolution* value);
static void display_display_widget_populate_refresh_rates (DisplayDisplayWidget* self);
static void display_display_widget_set_toggle_settings (DisplayDisplayWidget* self,
                                                 GtkMenuButton* value);
static void __lambda8_ (DisplayDisplayWidget* self);
static void ___lambda8__gtk_widget_destroy (GtkWidget* _sender,
                                     gpointer self);
static void __lambda9_ (DisplayDisplayWidget* self);
static void ___lambda9__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda10_ (Block4Data* _data4_);
static void ___lambda10__gtk_combo_box_changed (GtkComboBox* _sender,
                                         gpointer self);
static void __lambda11_ (Block4Data* _data4_);
static void ___lambda11__gtk_combo_box_changed (GtkComboBox* _sender,
                                         gpointer self);
static void __lambda12_ (Block4Data* _data4_);
static void ___lambda12__gtk_combo_box_changed (GtkComboBox* _sender,
                                         gpointer self);
static void display_display_widget_on_vm_transform_changed (DisplayDisplayWidget* self);
static void display_display_widget_on_monitor_modes_changed (DisplayDisplayWidget* self);
static void _display_display_widget_on_monitor_modes_changed_display_virtual_monitor_modes_changed (DisplayVirtualMonitor* _sender,
                                                                                             gpointer self);
static void _display_display_widget_on_vm_transform_changed_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self);
static gboolean _vala_double_array_contains (gdouble * stack,
                                      gssize stack_length,
                                      const gdouble needle);
static void _vala_array_add4 (gdouble* * array,
                       gint* length,
                       gint* size,
                       gdouble value);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gboolean ____lambda14_ (Block5Data* _data5_,
                        GtkTreeModel* model,
                        GtkTreePath* path,
                        GtkTreeIter* iter);
static gboolean _____lambda14__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                     GtkTreePath* path,
                                                     GtkTreeIter* iter,
                                                     gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean __lambda13_ (Block6Data* _data6_,
                      GtkTreeModel* model,
                      GtkTreePath* path,
                      GtkTreeIter* iter);
static gboolean ___lambda13__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                   GtkTreePath* path,
                                                   GtkTreeIter* iter,
                                                   gpointer self);
static gboolean display_display_widget_real_button_press_event (GtkWidget* base,
                                                         GdkEventButton* event);
static gboolean display_display_widget_real_button_release_event (GtkWidget* base,
                                                           GdkEventButton* event);
static gboolean display_display_widget_real_motion_notify_event (GtkWidget* base,
                                                          GdkEventMotion* event);
static void display_display_widget_real_get_preferred_width (GtkWidget* base,
                                                      gint* minimum_width,
                                                      gint* natural_width);
static void display_display_widget_real_get_preferred_height (GtkWidget* base,
                                                       gint* minimum_height,
                                                       gint* natural_height);
static void g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void display_display_widget_finalize (GObject * obj);
static GType display_display_widget_get_type_once (void);
static void _vala_display_display_widget_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_display_display_widget_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

DisplayResolution*
display_resolution_dup (const DisplayResolution* self)
{
	DisplayResolution* dup;
	dup = g_new0 (DisplayResolution, 1);
	memcpy (dup, self, sizeof (DisplayResolution));
	return dup;
}

void
display_resolution_free (DisplayResolution* self)
{
	g_free (self);
}

static GType
display_resolution_get_type_once (void)
{
	GType display_resolution_type_id;
	display_resolution_type_id = g_boxed_type_register_static ("DisplayResolution", (GBoxedCopyFunc) display_resolution_dup, (GBoxedFreeFunc) display_resolution_free);
	return display_resolution_type_id;
}

GType
display_resolution_get_type (void)
{
	static volatile gsize display_resolution_type_id__volatile = 0;
	if (g_once_init_enter (&display_resolution_type_id__volatile)) {
		GType display_resolution_type_id;
		display_resolution_type_id = display_resolution_get_type_once ();
		g_once_init_leave (&display_resolution_type_id__volatile, display_resolution_type_id);
	}
	return display_resolution_type_id__volatile;
}

static inline gpointer
display_display_widget_get_instance_private (DisplayDisplayWidget* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayDisplayWidget_private_offset);
}

static GType
display_display_widget_resolution_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME, "DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME", "name"}, {DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_MODE, "DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_MODE", "mode"}, {DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_TOTAL, "DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_TOTAL", "total"}, {0, NULL, NULL}};
	GType display_display_widget_resolution_columns_type_id;
	display_display_widget_resolution_columns_type_id = g_enum_register_static ("DisplayDisplayWidgetResolutionColumns", values);
	return display_display_widget_resolution_columns_type_id;
}

static GType
display_display_widget_resolution_columns_get_type (void)
{
	static volatile gsize display_display_widget_resolution_columns_type_id__volatile = 0;
	if (g_once_init_enter (&display_display_widget_resolution_columns_type_id__volatile)) {
		GType display_display_widget_resolution_columns_type_id;
		display_display_widget_resolution_columns_type_id = display_display_widget_resolution_columns_get_type_once ();
		g_once_init_leave (&display_display_widget_resolution_columns_type_id__volatile, display_display_widget_resolution_columns_type_id);
	}
	return display_display_widget_resolution_columns_type_id__volatile;
}

static GType
display_display_widget_rotation_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME, "DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME", "name"}, {DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE, "DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE", "value"}, {DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_TOTAL, "DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_TOTAL", "total"}, {0, NULL, NULL}};
	GType display_display_widget_rotation_columns_type_id;
	display_display_widget_rotation_columns_type_id = g_enum_register_static ("DisplayDisplayWidgetRotationColumns", values);
	return display_display_widget_rotation_columns_type_id;
}

static GType
display_display_widget_rotation_columns_get_type (void)
{
	static volatile gsize display_display_widget_rotation_columns_type_id__volatile = 0;
	if (g_once_init_enter (&display_display_widget_rotation_columns_type_id__volatile)) {
		GType display_display_widget_rotation_columns_type_id;
		display_display_widget_rotation_columns_type_id = display_display_widget_rotation_columns_get_type_once ();
		g_once_init_leave (&display_display_widget_rotation_columns_type_id__volatile, display_display_widget_rotation_columns_type_id);
	}
	return display_display_widget_rotation_columns_type_id__volatile;
}

static GType
display_display_widget_refresh_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_NAME, "DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_NAME", "name"}, {DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_VALUE, "DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_VALUE", "value"}, {DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_TOTAL, "DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_TOTAL", "total"}, {0, NULL, NULL}};
	GType display_display_widget_refresh_columns_type_id;
	display_display_widget_refresh_columns_type_id = g_enum_register_static ("DisplayDisplayWidgetRefreshColumns", values);
	return display_display_widget_refresh_columns_type_id;
}

static GType
display_display_widget_refresh_columns_get_type (void)
{
	static volatile gsize display_display_widget_refresh_columns_type_id__volatile = 0;
	if (g_once_init_enter (&display_display_widget_refresh_columns_type_id__volatile)) {
		GType display_display_widget_refresh_columns_type_id;
		display_display_widget_refresh_columns_type_id = display_display_widget_refresh_columns_get_type_once ();
		g_once_init_leave (&display_display_widget_refresh_columns_type_id__volatile, display_display_widget_refresh_columns_type_id);
	}
	return display_display_widget_refresh_columns_type_id__volatile;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		DisplayDisplayWidget* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->label);
		_g_free0 (_data4_->virtual_monitor_name);
		_g_object_unref0 (_data4_->virtual_monitor);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static void
__lambda7_ (DisplayDisplayWidget* self)
{
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_SET_AS_PRIMARY_SIGNAL], 0);
}

static void
___lambda7__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
	__lambda7_ ((DisplayDisplayWidget*) self);
}

static gboolean
_display_resolution_equal (const DisplayResolution * s1,
                           const DisplayResolution * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->width != s2->width) {
		return FALSE;
	}
	if (s1->height != s2->height) {
		return FALSE;
	}
	return TRUE;
}

static gboolean
_vala_display_resolution_array_contains (DisplayResolution * stack,
                                         gssize stack_length,
                                         const DisplayResolution * needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (_display_resolution_equal (&stack[i], needle) == TRUE) {
			return TRUE;
		}
	}
	return FALSE;
}

static void
_vala_array_add3 (DisplayResolution* * array,
                  gint* length,
                  gint* size,
                  const DisplayResolution* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (DisplayResolution, *array, *size);
	}
	(*array)[(*length)++] = *value;
}

static void
__lambda8_ (DisplayDisplayWidget* self)
{
	DisplayDisplayWindow* _tmp0_;
	_tmp0_ = self->display_window;
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
}

static void
___lambda8__gtk_widget_destroy (GtkWidget* _sender,
                                gpointer self)
{
	__lambda8_ ((DisplayDisplayWidget*) self);
}

static void
__lambda9_ (DisplayDisplayWidget* self)
{
	GtkComboBox* _tmp0_;
	GtkSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkComboBox* _tmp4_;
	GtkSwitch* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GtkComboBox* _tmp8_;
	GtkSwitch* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GtkComboBox* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	GtkComboBox* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	GtkComboBox* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	GtkSwitch* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	_tmp0_ = self->priv->resolution_combobox;
	_tmp1_ = self->priv->use_switch;
	_tmp2_ = gtk_switch_get_active (_tmp1_);
	_tmp3_ = _tmp2_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp3_);
	_tmp4_ = self->priv->rotation_combobox;
	_tmp5_ = self->priv->use_switch;
	_tmp6_ = gtk_switch_get_active (_tmp5_);
	_tmp7_ = _tmp6_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, _tmp7_);
	_tmp8_ = self->priv->refresh_combobox;
	_tmp9_ = self->priv->use_switch;
	_tmp10_ = gtk_switch_get_active (_tmp9_);
	_tmp11_ = _tmp10_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, _tmp11_);
	_tmp12_ = self->priv->rotation_combobox;
	_tmp13_ = gtk_combo_box_get_active (_tmp12_);
	_tmp14_ = _tmp13_;
	if (_tmp14_ == -1) {
		GtkComboBox* _tmp15_;
		_tmp15_ = self->priv->rotation_combobox;
		gtk_combo_box_set_active (_tmp15_, 0);
	}
	_tmp16_ = self->priv->resolution_combobox;
	_tmp17_ = gtk_combo_box_get_active (_tmp16_);
	_tmp18_ = _tmp17_;
	if (_tmp18_ == -1) {
		GtkComboBox* _tmp19_;
		_tmp19_ = self->priv->resolution_combobox;
		gtk_combo_box_set_active (_tmp19_, 0);
	}
	_tmp20_ = self->priv->refresh_combobox;
	_tmp21_ = gtk_combo_box_get_active (_tmp20_);
	_tmp22_ = _tmp21_;
	if (_tmp22_ == -1) {
		GtkComboBox* _tmp23_;
		_tmp23_ = self->priv->refresh_combobox;
		gtk_combo_box_set_active (_tmp23_, 0);
	}
	_tmp24_ = self->priv->use_switch;
	_tmp25_ = gtk_switch_get_active (_tmp24_);
	_tmp26_ = _tmp25_;
	if (_tmp26_) {
		GtkStyleContext* _tmp27_;
		_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) self);
		gtk_style_context_remove_class (_tmp27_, "disabled");
	} else {
		GtkStyleContext* _tmp28_;
		_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) self);
		gtk_style_context_add_class (_tmp28_, "disabled");
	}
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_ACTIVE_CHANGED_SIGNAL], 0);
}

static void
___lambda9__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda9_ ((DisplayDisplayWidget*) self);
}

static void
__lambda10_ (Block4Data* _data4_)
{
	DisplayDisplayWidget* self;
	GValue val = {0};
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GValue _tmp4_ = {0};
	DisplayMonitorMode* new_mode = NULL;
	GValue _tmp5_;
	DisplayMonitorMode* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	GtkComboBox* _tmp15_;
	self = _data4_->self;
	_tmp0_ = self->priv->resolution_combobox;
	gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	_tmp2_ = self->priv->resolution_list_store;
	_tmp3_ = iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp2_, &_tmp3_, (gint) DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_MODE, &_tmp4_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp4_;
	_tmp5_ = val;
	_tmp6_ = _g_object_ref0 (g_value_get_object (&_tmp5_));
	new_mode = _tmp6_;
	_tmp7_ = display_virtual_monitor_get_x (_data4_->virtual_monitor);
	_tmp8_ = _tmp7_;
	_tmp9_ = display_virtual_monitor_get_y (_data4_->virtual_monitor);
	_tmp10_ = _tmp9_;
	_tmp11_ = display_monitor_mode_get_width (new_mode);
	_tmp12_ = _tmp11_;
	_tmp13_ = display_monitor_mode_get_height (new_mode);
	_tmp14_ = _tmp13_;
	display_display_widget_set_geometry (self, _tmp8_, _tmp10_, (gint) _tmp12_, (gint) _tmp14_);
	display_virtual_monitor_set_current_mode (_data4_->virtual_monitor, new_mode);
	_tmp15_ = self->priv->rotation_combobox;
	gtk_combo_box_set_active (_tmp15_, 0);
	display_display_widget_populate_refresh_rates (self);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL], 0);
	_g_object_unref0 (new_mode);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

static void
___lambda10__gtk_combo_box_changed (GtkComboBox* _sender,
                                    gpointer self)
{
	__lambda10_ (self);
}

static void
__lambda11_ (Block4Data* _data4_)
{
	DisplayDisplayWidget* self;
	GValue val = {0};
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GValue _tmp4_ = {0};
	DisplayTransform transform = 0;
	GValue _tmp5_;
	DisplayTransform _tmp6_;
	DisplayTransform _tmp7_;
	self = _data4_->self;
	_tmp0_ = self->priv->rotation_combobox;
	gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	_tmp2_ = self->priv->rotation_list_store;
	_tmp3_ = iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp2_, &_tmp3_, (gint) DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE, &_tmp4_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp4_;
	_tmp5_ = val;
	transform = (DisplayTransform) g_value_get_int (&_tmp5_);
	_tmp6_ = transform;
	display_virtual_monitor_set_transform (_data4_->virtual_monitor, _tmp6_);
	_tmp7_ = transform;
	switch (_tmp7_) {
		case DISPLAY_TRANSFORM_NORMAL:
		{
			gint _tmp8_ = 0;
			gint _tmp9_ = 0;
			GtkLabel* _tmp10_;
			GtkLabel* _tmp11_;
			const gchar* _tmp12_;
			display_virtual_monitor_get_current_mode_size (_data4_->virtual_monitor, &_tmp8_, &_tmp9_);
			self->priv->real_width = _tmp8_;
			self->priv->real_height = _tmp9_;
			_tmp10_ = _data4_->label;
			gtk_label_set_angle (_tmp10_, (gdouble) 0);
			_tmp11_ = _data4_->label;
			_tmp12_ = _data4_->virtual_monitor_name;
			gtk_label_set_label (_tmp11_, _tmp12_);
			break;
		}
		case DISPLAY_TRANSFORM_ROTATION_90:
		{
			gint _tmp13_ = 0;
			gint _tmp14_ = 0;
			GtkLabel* _tmp15_;
			GtkLabel* _tmp16_;
			const gchar* _tmp17_;
			display_virtual_monitor_get_current_mode_size (_data4_->virtual_monitor, &_tmp13_, &_tmp14_);
			self->priv->real_height = _tmp13_;
			self->priv->real_width = _tmp14_;
			_tmp15_ = _data4_->label;
			gtk_label_set_angle (_tmp15_, (gdouble) 270);
			_tmp16_ = _data4_->label;
			_tmp17_ = _data4_->virtual_monitor_name;
			gtk_label_set_label (_tmp16_, _tmp17_);
			break;
		}
		case DISPLAY_TRANSFORM_ROTATION_180:
		{
			gint _tmp18_ = 0;
			gint _tmp19_ = 0;
			GtkLabel* _tmp20_;
			GtkLabel* _tmp21_;
			const gchar* _tmp22_;
			display_virtual_monitor_get_current_mode_size (_data4_->virtual_monitor, &_tmp18_, &_tmp19_);
			self->priv->real_width = _tmp18_;
			self->priv->real_height = _tmp19_;
			_tmp20_ = _data4_->label;
			gtk_label_set_angle (_tmp20_, (gdouble) 180);
			_tmp21_ = _data4_->label;
			_tmp22_ = _data4_->virtual_monitor_name;
			gtk_label_set_label (_tmp21_, _tmp22_);
			break;
		}
		case DISPLAY_TRANSFORM_ROTATION_270:
		{
			gint _tmp23_ = 0;
			gint _tmp24_ = 0;
			GtkLabel* _tmp25_;
			GtkLabel* _tmp26_;
			const gchar* _tmp27_;
			display_virtual_monitor_get_current_mode_size (_data4_->virtual_monitor, &_tmp23_, &_tmp24_);
			self->priv->real_height = _tmp23_;
			self->priv->real_width = _tmp24_;
			_tmp25_ = _data4_->label;
			gtk_label_set_angle (_tmp25_, (gdouble) 90);
			_tmp26_ = _data4_->label;
			_tmp27_ = _data4_->virtual_monitor_name;
			gtk_label_set_label (_tmp26_, _tmp27_);
			break;
		}
		case DISPLAY_TRANSFORM_FLIPPED:
		{
			gint _tmp28_ = 0;
			gint _tmp29_ = 0;
			GtkLabel* _tmp30_;
			GtkLabel* _tmp31_;
			const gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			display_virtual_monitor_get_current_mode_size (_data4_->virtual_monitor, &_tmp28_, &_tmp29_);
			self->priv->real_width = _tmp28_;
			self->priv->real_height = _tmp29_;
			_tmp30_ = _data4_->label;
			gtk_label_set_angle (_tmp30_, (gdouble) 0);
			_tmp31_ = _data4_->label;
			_tmp32_ = _data4_->virtual_monitor_name;
			_tmp33_ = g_utf8_strreverse (_tmp32_, (gssize) -1);
			_tmp34_ = _tmp33_;
			gtk_label_set_label (_tmp31_, _tmp34_);
			_g_free0 (_tmp34_);
			break;
		}
		case DISPLAY_TRANSFORM_FLIPPED_ROTATION_90:
		{
			gint _tmp35_ = 0;
			gint _tmp36_ = 0;
			GtkLabel* _tmp37_;
			GtkLabel* _tmp38_;
			const gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			display_virtual_monitor_get_current_mode_size (_data4_->virtual_monitor, &_tmp35_, &_tmp36_);
			self->priv->real_height = _tmp35_;
			self->priv->real_width = _tmp36_;
			_tmp37_ = _data4_->label;
			gtk_label_set_angle (_tmp37_, (gdouble) 270);
			_tmp38_ = _data4_->label;
			_tmp39_ = _data4_->virtual_monitor_name;
			_tmp40_ = g_utf8_strreverse (_tmp39_, (gssize) -1);
			_tmp41_ = _tmp40_;
			gtk_label_set_label (_tmp38_, _tmp41_);
			_g_free0 (_tmp41_);
			break;
		}
		case DISPLAY_TRANSFORM_FLIPPED_ROTATION_180:
		{
			gint _tmp42_ = 0;
			gint _tmp43_ = 0;
			GtkLabel* _tmp44_;
			GtkLabel* _tmp45_;
			const gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
			display_virtual_monitor_get_current_mode_size (_data4_->virtual_monitor, &_tmp42_, &_tmp43_);
			self->priv->real_width = _tmp42_;
			self->priv->real_height = _tmp43_;
			_tmp44_ = _data4_->label;
			gtk_label_set_angle (_tmp44_, (gdouble) 180);
			_tmp45_ = _data4_->label;
			_tmp46_ = _data4_->virtual_monitor_name;
			_tmp47_ = g_utf8_strreverse (_tmp46_, (gssize) -1);
			_tmp48_ = _tmp47_;
			gtk_label_set_label (_tmp45_, _tmp48_);
			_g_free0 (_tmp48_);
			break;
		}
		case DISPLAY_TRANSFORM_FLIPPED_ROTATION_270:
		{
			gint _tmp49_ = 0;
			gint _tmp50_ = 0;
			GtkLabel* _tmp51_;
			GtkLabel* _tmp52_;
			const gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			display_virtual_monitor_get_current_mode_size (_data4_->virtual_monitor, &_tmp49_, &_tmp50_);
			self->priv->real_height = _tmp49_;
			self->priv->real_width = _tmp50_;
			_tmp51_ = _data4_->label;
			gtk_label_set_angle (_tmp51_, (gdouble) 90);
			_tmp52_ = _data4_->label;
			_tmp53_ = _data4_->virtual_monitor_name;
			_tmp54_ = g_utf8_strreverse (_tmp53_, (gssize) -1);
			_tmp55_ = _tmp54_;
			gtk_label_set_label (_tmp52_, _tmp55_);
			_g_free0 (_tmp55_);
			break;
		}
		default:
		break;
	}
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL], 0);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

static void
___lambda11__gtk_combo_box_changed (GtkComboBox* _sender,
                                    gpointer self)
{
	__lambda11_ (self);
}

static void
__lambda12_ (Block4Data* _data4_)
{
	DisplayDisplayWidget* self;
	GValue val = {0};
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GValue _tmp4_ = {0};
	DisplayMonitorMode* new_mode = NULL;
	GValue _tmp5_;
	DisplayMonitorMode* _tmp6_;
	GtkComboBox* _tmp7_;
	self = _data4_->self;
	_tmp0_ = self->priv->refresh_combobox;
	gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	_tmp2_ = self->priv->refresh_list_store;
	_tmp3_ = iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp2_, &_tmp3_, (gint) DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_MODE, &_tmp4_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp4_;
	_tmp5_ = val;
	_tmp6_ = _g_object_ref0 (g_value_get_object (&_tmp5_));
	new_mode = _tmp6_;
	display_virtual_monitor_set_current_mode (_data4_->virtual_monitor, new_mode);
	_tmp7_ = self->priv->rotation_combobox;
	gtk_combo_box_set_active (_tmp7_, 0);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL], 0);
	_g_object_unref0 (new_mode);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

static void
___lambda12__gtk_combo_box_changed (GtkComboBox* _sender,
                                    gpointer self)
{
	__lambda12_ (self);
}

static void
_display_display_widget_on_monitor_modes_changed_display_virtual_monitor_modes_changed (DisplayVirtualMonitor* _sender,
                                                                                        gpointer self)
{
	display_display_widget_on_monitor_modes_changed ((DisplayDisplayWidget*) self);
}

static void
_display_display_widget_on_vm_transform_changed_g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self)
{
	display_display_widget_on_vm_transform_changed ((DisplayDisplayWidget*) self);
}

DisplayDisplayWidget*
display_display_widget_construct (GType object_type,
                                  DisplayVirtualMonitor* virtual_monitor)
{
	DisplayDisplayWidget * self = NULL;
	Block4Data* _data4_;
	DisplayVirtualMonitor* _tmp0_;
	DisplayVirtualMonitor* _tmp1_;
	DisplayDisplayWindow* _tmp2_;
	GdkEventMask _tmp3_;
	GdkEventMask _tmp4_;
	GdkEventMask _tmp5_;
	GdkEventMask _tmp6_;
	GdkEventMask _tmp7_;
	GdkEventMask _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkButton* _tmp16_;
	GtkButton* _tmp17_;
	GtkButton* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	GtkLabel* use_label = NULL;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkSwitch* _tmp28_;
	GtkSwitch* _tmp29_;
	GtkSwitch* _tmp30_;
	GtkLabel* resolution_label = NULL;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkListStore* _tmp33_;
	GtkListStore* _tmp34_;
	GtkComboBox* _tmp35_;
	GtkComboBox* _tmp36_;
	GtkSwitch* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	GtkCellRendererText* text_renderer = NULL;
	GtkCellRendererText* _tmp40_;
	GtkComboBox* _tmp41_;
	GtkCellRendererText* _tmp42_;
	GtkComboBox* _tmp43_;
	GtkCellRendererText* _tmp44_;
	GtkLabel* rotation_label = NULL;
	GtkLabel* _tmp45_;
	GtkLabel* _tmp46_;
	GtkListStore* _tmp47_;
	GtkListStore* _tmp48_;
	GtkComboBox* _tmp49_;
	GtkComboBox* _tmp50_;
	GtkSwitch* _tmp51_;
	gboolean _tmp52_;
	gboolean _tmp53_;
	GtkCellRendererText* _tmp54_;
	GtkComboBox* _tmp55_;
	GtkCellRendererText* _tmp56_;
	GtkComboBox* _tmp57_;
	GtkCellRendererText* _tmp58_;
	GtkLabel* refresh_label = NULL;
	GtkLabel* _tmp59_;
	GtkLabel* _tmp60_;
	GtkListStore* _tmp61_;
	GtkListStore* _tmp62_;
	GtkComboBox* _tmp63_;
	GtkComboBox* _tmp64_;
	GtkSwitch* _tmp65_;
	gboolean _tmp66_;
	gboolean _tmp67_;
	GtkCellRendererText* _tmp68_;
	GtkComboBox* _tmp69_;
	GtkCellRendererText* _tmp70_;
	GtkComboBox* _tmp71_;
	GtkCellRendererText* _tmp72_;
	DisplayResolution* resolutions = NULL;
	DisplayResolution* _tmp81_;
	gint resolutions_length1;
	gint _resolutions_size_;
	gboolean resolution_set = FALSE;
	GtkGrid* popover_grid = NULL;
	GtkGrid* _tmp113_;
	GtkGrid* _tmp114_;
	GtkGrid* _tmp115_;
	GtkGrid* _tmp116_;
	GtkGrid* _tmp117_;
	GtkLabel* _tmp118_;
	GtkGrid* _tmp119_;
	GtkSwitch* _tmp120_;
	GtkGrid* _tmp121_;
	GtkLabel* _tmp122_;
	GtkGrid* _tmp123_;
	GtkComboBox* _tmp124_;
	GtkGrid* _tmp125_;
	GtkLabel* _tmp126_;
	GtkGrid* _tmp127_;
	GtkComboBox* _tmp128_;
	GtkGrid* _tmp129_;
	GtkLabel* _tmp130_;
	GtkGrid* _tmp131_;
	GtkComboBox* _tmp132_;
	GtkGrid* _tmp133_;
	GtkPopover* popover = NULL;
	GtkMenuButton* _tmp134_;
	GtkPopover* _tmp135_;
	GtkPopover* _tmp136_;
	GtkPopover* _tmp137_;
	GtkGrid* _tmp138_;
	GtkMenuButton* _tmp139_;
	GtkMenuButton* _tmp140_;
	GtkMenuButton* _tmp141_;
	GtkImage* _tmp142_;
	GtkImage* _tmp143_;
	GtkMenuButton* _tmp144_;
	GtkMenuButton* _tmp145_;
	GtkMenuButton* _tmp146_;
	GtkMenuButton* _tmp147_;
	GtkPopover* _tmp148_;
	GtkMenuButton* _tmp149_;
	GtkMenuButton* _tmp150_;
	GtkStyleContext* _tmp151_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp152_;
	GtkGrid* _tmp153_;
	GtkButton* _tmp154_;
	GtkGrid* _tmp155_;
	GtkMenuButton* _tmp156_;
	GtkGrid* _tmp157_;
	GtkLabel* _tmp158_;
	gboolean _tmp159_;
	gboolean _tmp160_;
	GtkGrid* _tmp161_;
	DisplayDisplayWindow* _tmp162_;
	GtkSwitch* _tmp163_;
	gboolean _tmp164_;
	gboolean _tmp165_;
	GtkComboBox* _tmp167_;
	GtkComboBox* _tmp168_;
	GtkComboBox* _tmp169_;
	GtkComboBox* _tmp170_;
	DisplayTransform _tmp171_;
	DisplayTransform _tmp172_;
	g_return_val_if_fail (virtual_monitor != NULL, NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (virtual_monitor);
	_g_object_unref0 (_data4_->virtual_monitor);
	_data4_->virtual_monitor = _tmp0_;
	self = (DisplayDisplayWidget*) g_object_new (object_type, NULL);
	_data4_->self = g_object_ref (self);
	_tmp1_ = _g_object_ref0 (_data4_->virtual_monitor);
	_g_object_unref0 (self->virtual_monitor);
	self->virtual_monitor = _tmp1_;
	_tmp2_ = display_display_window_new (_data4_->virtual_monitor);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->display_window);
	self->display_window = _tmp2_;
	_tmp3_ = gtk_widget_get_events ((GtkWidget*) self);
	_tmp4_ = _tmp3_;
	gtk_widget_set_events ((GtkWidget*) self, _tmp4_ | GDK_BUTTON_PRESS_MASK);
	_tmp5_ = gtk_widget_get_events ((GtkWidget*) self);
	_tmp6_ = _tmp5_;
	gtk_widget_set_events ((GtkWidget*) self, _tmp6_ | GDK_BUTTON_RELEASE_MASK);
	_tmp7_ = gtk_widget_get_events ((GtkWidget*) self);
	_tmp8_ = _tmp7_;
	gtk_widget_set_events ((GtkWidget*) self, _tmp8_ | GDK_POINTER_MOTION_MASK);
	display_virtual_monitor_get_current_mode_size (_data4_->virtual_monitor, &_tmp9_, &_tmp10_);
	self->priv->real_width = _tmp9_;
	self->priv->real_height = _tmp10_;
	_tmp11_ = (GtkButton*) gtk_button_new_from_icon_name ("non-starred-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp11_);
	_tmp12_ = _tmp11_;
	display_display_widget_set_primary_image (self, _tmp12_);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = self->priv->_primary_image;
	g_object_set ((GtkWidget*) _tmp13_, "margin", 6, NULL);
	_tmp14_ = self->priv->_primary_image;
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
	gtk_style_context_add_class (_tmp15_, GTK_STYLE_CLASS_FLAT);
	_tmp16_ = self->priv->_primary_image;
	gtk_widget_set_halign ((GtkWidget*) _tmp16_, GTK_ALIGN_START);
	_tmp17_ = self->priv->_primary_image;
	gtk_widget_set_valign ((GtkWidget*) _tmp17_, GTK_ALIGN_START);
	_tmp18_ = self->priv->_primary_image;
	g_signal_connect_object (_tmp18_, "clicked", (GCallback) ___lambda7__gtk_button_clicked, self, 0);
	_tmp19_ = display_virtual_monitor_get_display_name (_data4_->virtual_monitor);
	_tmp20_ = g_strdup (_tmp19_);
	_data4_->virtual_monitor_name = _tmp20_;
	_tmp21_ = _data4_->virtual_monitor_name;
	_tmp22_ = (GtkLabel*) gtk_label_new (_tmp21_);
	g_object_ref_sink (_tmp22_);
	_data4_->label = _tmp22_;
	_tmp23_ = _data4_->label;
	gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_CENTER);
	_tmp24_ = _data4_->label;
	gtk_widget_set_valign ((GtkWidget*) _tmp24_, GTK_ALIGN_CENTER);
	_tmp25_ = _data4_->label;
	g_object_set ((GtkWidget*) _tmp25_, "expand", TRUE, NULL);
	_tmp26_ = (GtkLabel*) gtk_label_new (_ ("Use this display:"));
	g_object_ref_sink (_tmp26_);
	use_label = _tmp26_;
	_tmp27_ = use_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp27_, GTK_ALIGN_END);
	_tmp28_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->use_switch);
	self->priv->use_switch = _tmp28_;
	_tmp29_ = self->priv->use_switch;
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_START);
	_tmp30_ = self->priv->use_switch;
	g_object_bind_property_with_closures ((GObject*) _data4_->virtual_monitor, "is-active", (GObject*) _tmp30_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp31_ = (GtkLabel*) gtk_label_new (_ ("Resolution:"));
	g_object_ref_sink (_tmp31_);
	resolution_label = _tmp31_;
	_tmp32_ = resolution_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp32_, GTK_ALIGN_END);
	_tmp33_ = gtk_list_store_new ((gint) DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_TOTAL, G_TYPE_STRING, DISPLAY_TYPE_MONITOR_MODE, -1);
	_g_object_unref0 (self->priv->resolution_list_store);
	self->priv->resolution_list_store = _tmp33_;
	_tmp34_ = self->priv->resolution_list_store;
	_tmp35_ = (GtkComboBox*) gtk_combo_box_new_with_model ((GtkTreeModel*) _tmp34_);
	g_object_ref_sink (_tmp35_);
	_g_object_unref0 (self->priv->resolution_combobox);
	self->priv->resolution_combobox = _tmp35_;
	_tmp36_ = self->priv->resolution_combobox;
	_tmp37_ = self->priv->use_switch;
	_tmp38_ = gtk_switch_get_active (_tmp37_);
	_tmp39_ = _tmp38_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp36_, _tmp39_);
	_tmp40_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp40_);
	text_renderer = _tmp40_;
	_tmp41_ = self->priv->resolution_combobox;
	_tmp42_ = text_renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp41_, (GtkCellRenderer*) _tmp42_, TRUE);
	_tmp43_ = self->priv->resolution_combobox;
	_tmp44_ = text_renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp43_, (GtkCellRenderer*) _tmp44_, "text", (gint) DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME);
	_tmp45_ = (GtkLabel*) gtk_label_new (_ ("Screen Rotation:"));
	g_object_ref_sink (_tmp45_);
	rotation_label = _tmp45_;
	_tmp46_ = rotation_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp46_, GTK_ALIGN_END);
	_tmp47_ = gtk_list_store_new ((gint) DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_TOTAL, G_TYPE_STRING, G_TYPE_INT, -1);
	_g_object_unref0 (self->priv->rotation_list_store);
	self->priv->rotation_list_store = _tmp47_;
	_tmp48_ = self->priv->rotation_list_store;
	_tmp49_ = (GtkComboBox*) gtk_combo_box_new_with_model ((GtkTreeModel*) _tmp48_);
	g_object_ref_sink (_tmp49_);
	_g_object_unref0 (self->priv->rotation_combobox);
	self->priv->rotation_combobox = _tmp49_;
	_tmp50_ = self->priv->rotation_combobox;
	_tmp51_ = self->priv->use_switch;
	_tmp52_ = gtk_switch_get_active (_tmp51_);
	_tmp53_ = _tmp52_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp50_, _tmp53_);
	_tmp54_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp54_);
	_g_object_unref0 (text_renderer);
	text_renderer = _tmp54_;
	_tmp55_ = self->priv->rotation_combobox;
	_tmp56_ = text_renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp55_, (GtkCellRenderer*) _tmp56_, TRUE);
	_tmp57_ = self->priv->rotation_combobox;
	_tmp58_ = text_renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp57_, (GtkCellRenderer*) _tmp58_, "text", (gint) DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME);
	_tmp59_ = (GtkLabel*) gtk_label_new (_ ("Refresh Rate:"));
	g_object_ref_sink (_tmp59_);
	refresh_label = _tmp59_;
	_tmp60_ = refresh_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp60_, GTK_ALIGN_END);
	_tmp61_ = gtk_list_store_new ((gint) DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_TOTAL, G_TYPE_STRING, DISPLAY_TYPE_MONITOR_MODE, -1);
	_g_object_unref0 (self->priv->refresh_list_store);
	self->priv->refresh_list_store = _tmp61_;
	_tmp62_ = self->priv->refresh_list_store;
	_tmp63_ = (GtkComboBox*) gtk_combo_box_new_with_model ((GtkTreeModel*) _tmp62_);
	g_object_ref_sink (_tmp63_);
	_g_object_unref0 (self->priv->refresh_combobox);
	self->priv->refresh_combobox = _tmp63_;
	_tmp64_ = self->priv->refresh_combobox;
	_tmp65_ = self->priv->use_switch;
	_tmp66_ = gtk_switch_get_active (_tmp65_);
	_tmp67_ = _tmp66_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp64_, _tmp67_);
	_tmp68_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp68_);
	_g_object_unref0 (text_renderer);
	text_renderer = _tmp68_;
	_tmp69_ = self->priv->refresh_combobox;
	_tmp70_ = text_renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp69_, (GtkCellRenderer*) _tmp70_, TRUE);
	_tmp71_ = self->priv->refresh_combobox;
	_tmp72_ = text_renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp71_, (GtkCellRenderer*) _tmp72_, "text", (gint) DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_NAME);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp73_ = FALSE;
			_tmp73_ = TRUE;
			while (TRUE) {
				GtkTreeIter iter = {0};
				GtkListStore* _tmp75_;
				GtkTreeIter _tmp76_ = {0};
				GtkListStore* _tmp77_;
				GtkTreeIter _tmp78_;
				gchar* _tmp79_;
				gchar* _tmp80_;
				if (!_tmp73_) {
					gint _tmp74_;
					_tmp74_ = i;
					i = _tmp74_ + 1;
				}
				_tmp73_ = FALSE;
				if (!(i <= ((gint) DISPLAY_TRANSFORM_FLIPPED_ROTATION_270))) {
					break;
				}
				_tmp75_ = self->priv->rotation_list_store;
				gtk_list_store_append (_tmp75_, &_tmp76_);
				iter = _tmp76_;
				_tmp77_ = self->priv->rotation_list_store;
				_tmp78_ = iter;
				_tmp79_ = display_transform_to_string ((DisplayTransform) i);
				_tmp80_ = _tmp79_;
				gtk_list_store_set (_tmp77_, &_tmp78_, DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME, _tmp80_, DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE, i, -1);
				_g_free0 (_tmp80_);
			}
		}
	}
	_tmp81_ = g_new0 (DisplayResolution, 0);
	resolutions = _tmp81_;
	resolutions_length1 = 0;
	_resolutions_size_ = resolutions_length1;
	resolution_set = FALSE;
	{
		GeeLinkedList* _mode_list = NULL;
		GeeLinkedList* _tmp82_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp83_;
		gint _tmp84_;
		gint _tmp85_;
		gint _mode_index = 0;
		_tmp82_ = display_virtual_monitor_get_available_modes (_data4_->virtual_monitor);
		_mode_list = _tmp82_;
		_tmp83_ = _mode_list;
		_tmp84_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp83_);
		_tmp85_ = _tmp84_;
		_mode_size = _tmp85_;
		_mode_index = -1;
		while (TRUE) {
			gint _tmp86_;
			gint _tmp87_;
			DisplayMonitorMode* mode = NULL;
			GeeLinkedList* _tmp88_;
			gpointer _tmp89_;
			gint mode_width = 0;
			DisplayMonitorMode* _tmp90_;
			gint _tmp91_;
			gint _tmp92_;
			gint mode_height = 0;
			DisplayMonitorMode* _tmp93_;
			gint _tmp94_;
			gint _tmp95_;
			DisplayResolution res = {0};
			DisplayResolution _tmp96_ = {0};
			DisplayResolution _tmp97_;
			DisplayResolution* _tmp98_;
			gint _tmp98__length1;
			DisplayResolution _tmp99_;
			GtkTreeIter iter = {0};
			GtkListStore* _tmp100_;
			GtkTreeIter _tmp101_ = {0};
			GtkListStore* _tmp102_;
			GtkTreeIter _tmp103_;
			DisplayMonitorMode* _tmp104_;
			const gchar* _tmp105_;
			DisplayMonitorMode* _tmp106_;
			DisplayMonitorMode* _tmp107_;
			gboolean _tmp108_;
			gboolean _tmp109_;
			_mode_index = _mode_index + 1;
			_tmp86_ = _mode_index;
			_tmp87_ = _mode_size;
			if (!(_tmp86_ < _tmp87_)) {
				break;
			}
			_tmp88_ = _mode_list;
			_tmp89_ = gee_abstract_list_get ((GeeAbstractList*) _tmp88_, _mode_index);
			mode = (DisplayMonitorMode*) _tmp89_;
			_tmp90_ = mode;
			_tmp91_ = display_monitor_mode_get_width (_tmp90_);
			_tmp92_ = _tmp91_;
			mode_width = _tmp92_;
			_tmp93_ = mode;
			_tmp94_ = display_monitor_mode_get_height (_tmp93_);
			_tmp95_ = _tmp94_;
			mode_height = _tmp95_;
			_tmp96_.width = (guint) mode_width;
			_tmp96_.height = (guint) mode_height;
			res = _tmp96_;
			_tmp97_ = res;
			_tmp98_ = resolutions;
			_tmp98__length1 = resolutions_length1;
			if (_vala_display_resolution_array_contains (_tmp98_, _tmp98__length1, &_tmp97_)) {
				_g_object_unref0 (mode);
				continue;
			}
			_tmp99_ = res;
			_vala_array_add3 (&resolutions, &resolutions_length1, &_resolutions_size_, &_tmp99_);
			_tmp100_ = self->priv->resolution_list_store;
			gtk_list_store_append (_tmp100_, &_tmp101_);
			iter = _tmp101_;
			_tmp102_ = self->priv->resolution_list_store;
			_tmp103_ = iter;
			_tmp104_ = mode;
			_tmp105_ = display_monitor_mode_get_resolution (_tmp104_);
			_tmp106_ = mode;
			gtk_list_store_set (_tmp102_, &_tmp103_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME, _tmp105_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_MODE, _tmp106_, -1);
			_tmp107_ = mode;
			_tmp108_ = display_monitor_mode_get_is_current (_tmp107_);
			_tmp109_ = _tmp108_;
			if (_tmp109_) {
				GtkComboBox* _tmp110_;
				GtkTreeIter _tmp111_;
				_tmp110_ = self->priv->resolution_combobox;
				_tmp111_ = iter;
				gtk_combo_box_set_active_iter (_tmp110_, &_tmp111_);
				resolution_set = TRUE;
			}
			_g_object_unref0 (mode);
		}
		_g_object_unref0 (_mode_list);
	}
	if (!resolution_set) {
		GtkComboBox* _tmp112_;
		_tmp112_ = self->priv->resolution_combobox;
		gtk_combo_box_set_active (_tmp112_, 0);
	}
	display_display_widget_populate_refresh_rates (self);
	_tmp113_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp113_);
	popover_grid = _tmp113_;
	_tmp114_ = popover_grid;
	gtk_grid_set_column_spacing (_tmp114_, 12);
	_tmp115_ = popover_grid;
	gtk_grid_set_row_spacing (_tmp115_, 6);
	_tmp116_ = popover_grid;
	g_object_set ((GtkWidget*) _tmp116_, "margin", 12, NULL);
	_tmp117_ = popover_grid;
	_tmp118_ = use_label;
	gtk_grid_attach (_tmp117_, (GtkWidget*) _tmp118_, 0, 0, 1, 1);
	_tmp119_ = popover_grid;
	_tmp120_ = self->priv->use_switch;
	gtk_grid_attach (_tmp119_, (GtkWidget*) _tmp120_, 1, 0, 1, 1);
	_tmp121_ = popover_grid;
	_tmp122_ = resolution_label;
	gtk_grid_attach (_tmp121_, (GtkWidget*) _tmp122_, 0, 1, 1, 1);
	_tmp123_ = popover_grid;
	_tmp124_ = self->priv->resolution_combobox;
	gtk_grid_attach (_tmp123_, (GtkWidget*) _tmp124_, 1, 1, 1, 1);
	_tmp125_ = popover_grid;
	_tmp126_ = rotation_label;
	gtk_grid_attach (_tmp125_, (GtkWidget*) _tmp126_, 0, 2, 1, 1);
	_tmp127_ = popover_grid;
	_tmp128_ = self->priv->rotation_combobox;
	gtk_grid_attach (_tmp127_, (GtkWidget*) _tmp128_, 1, 2, 1, 1);
	_tmp129_ = popover_grid;
	_tmp130_ = refresh_label;
	gtk_grid_attach (_tmp129_, (GtkWidget*) _tmp130_, 0, 3, 1, 1);
	_tmp131_ = popover_grid;
	_tmp132_ = self->priv->refresh_combobox;
	gtk_grid_attach (_tmp131_, (GtkWidget*) _tmp132_, 1, 3, 1, 1);
	_tmp133_ = popover_grid;
	gtk_widget_show_all ((GtkWidget*) _tmp133_);
	_tmp134_ = self->priv->_toggle_settings;
	_tmp135_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) _tmp134_);
	g_object_ref_sink (_tmp135_);
	popover = _tmp135_;
	_tmp136_ = popover;
	gtk_popover_set_position (_tmp136_, GTK_POS_BOTTOM);
	_tmp137_ = popover;
	_tmp138_ = popover_grid;
	gtk_container_add ((GtkContainer*) _tmp137_, (GtkWidget*) _tmp138_);
	_tmp139_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp139_);
	_tmp140_ = _tmp139_;
	display_display_widget_set_toggle_settings (self, _tmp140_);
	_g_object_unref0 (_tmp140_);
	_tmp141_ = self->priv->_toggle_settings;
	_tmp142_ = (GtkImage*) gtk_image_new_from_icon_name ("open-menu-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp142_);
	_tmp143_ = _tmp142_;
	gtk_button_set_image ((GtkButton*) _tmp141_, (GtkWidget*) _tmp143_);
	_g_object_unref0 (_tmp143_);
	_tmp144_ = self->priv->_toggle_settings;
	gtk_widget_set_halign ((GtkWidget*) _tmp144_, GTK_ALIGN_END);
	_tmp145_ = self->priv->_toggle_settings;
	gtk_widget_set_valign ((GtkWidget*) _tmp145_, GTK_ALIGN_START);
	_tmp146_ = self->priv->_toggle_settings;
	g_object_set ((GtkWidget*) _tmp146_, "margin", 6, NULL);
	_tmp147_ = self->priv->_toggle_settings;
	_tmp148_ = popover;
	gtk_menu_button_set_popover (_tmp147_, _tmp148_);
	_tmp149_ = self->priv->_toggle_settings;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp149_, _ ("Configure display"));
	_tmp150_ = self->priv->_toggle_settings;
	_tmp151_ = gtk_widget_get_style_context ((GtkWidget*) _tmp150_);
	gtk_style_context_add_class (_tmp151_, GTK_STYLE_CLASS_FLAT);
	_tmp152_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp152_);
	grid = _tmp152_;
	_tmp153_ = grid;
	_tmp154_ = self->priv->_primary_image;
	gtk_grid_attach (_tmp153_, (GtkWidget*) _tmp154_, 0, 0, 1, 1);
	_tmp155_ = grid;
	_tmp156_ = self->priv->_toggle_settings;
	gtk_grid_attach (_tmp155_, (GtkWidget*) _tmp156_, 2, 0, 1, 1);
	_tmp157_ = grid;
	_tmp158_ = _data4_->label;
	gtk_grid_attach (_tmp157_, (GtkWidget*) _tmp158_, 0, 0, 3, 2);
	_tmp159_ = display_virtual_monitor_get_primary (_data4_->virtual_monitor);
	_tmp160_ = _tmp159_;
	display_display_widget_set_primary (self, _tmp160_);
	_tmp161_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp161_);
	_tmp162_ = self->display_window;
	gtk_window_set_attached_to ((GtkWindow*) _tmp162_, (GtkWidget*) self);
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) ___lambda8__gtk_widget_destroy, self, 0);
	_tmp163_ = self->priv->use_switch;
	g_signal_connect_object ((GObject*) _tmp163_, "notify::active", (GCallback) ___lambda9__g_object_notify, self, 0);
	_tmp164_ = display_virtual_monitor_get_is_active (_data4_->virtual_monitor);
	_tmp165_ = _tmp164_;
	if (!_tmp165_) {
		GtkStyleContext* _tmp166_;
		_tmp166_ = gtk_widget_get_style_context ((GtkWidget*) self);
		gtk_style_context_add_class (_tmp166_, "disabled");
	}
	_tmp167_ = self->priv->resolution_combobox;
	g_signal_connect_data (_tmp167_, "changed", (GCallback) ___lambda10__gtk_combo_box_changed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	_tmp168_ = self->priv->rotation_combobox;
	g_signal_connect_data (_tmp168_, "changed", (GCallback) ___lambda11__gtk_combo_box_changed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	_tmp169_ = self->priv->refresh_combobox;
	g_signal_connect_data (_tmp169_, "changed", (GCallback) ___lambda12__gtk_combo_box_changed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	_tmp170_ = self->priv->rotation_combobox;
	_tmp171_ = display_virtual_monitor_get_transform (_data4_->virtual_monitor);
	_tmp172_ = _tmp171_;
	gtk_combo_box_set_active (_tmp170_, (gint) _tmp172_);
	display_display_widget_on_vm_transform_changed (self);
	g_signal_connect_object (_data4_->virtual_monitor, "modes-changed", (GCallback) _display_display_widget_on_monitor_modes_changed_display_virtual_monitor_modes_changed, self, 0);
	g_signal_connect_object ((GObject*) _data4_->virtual_monitor, "notify::transform", (GCallback) _display_display_widget_on_vm_transform_changed_g_object_notify, self, 0);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL], 0);
	_g_object_unref0 (grid);
	_g_object_unref0 (popover);
	_g_object_unref0 (popover_grid);
	resolutions = (g_free (resolutions), NULL);
	_g_object_unref0 (refresh_label);
	_g_object_unref0 (rotation_label);
	_g_object_unref0 (text_renderer);
	_g_object_unref0 (resolution_label);
	_g_object_unref0 (use_label);
	block4_data_unref (_data4_);
	_data4_ = NULL;
	return self;
}

DisplayDisplayWidget*
display_display_widget_new (DisplayVirtualMonitor* virtual_monitor)
{
	return display_display_widget_construct (DISPLAY_TYPE_DISPLAY_WIDGET, virtual_monitor);
}

static gboolean
_vala_double_array_contains (gdouble * stack,
                             gssize stack_length,
                             const gdouble needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}

static void
_vala_array_add4 (gdouble* * array,
                  gint* length,
                  gint* size,
                  gdouble value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gdouble, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
display_display_widget_populate_refresh_rates (DisplayDisplayWidget* self)
{
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	gint added = 0;
	GtkComboBox* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
	GtkComboBox* _tmp57_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->refresh_list_store;
	gtk_list_store_clear (_tmp0_);
	added = 0;
	_tmp1_ = self->priv->resolution_combobox;
	_tmp3_ = gtk_combo_box_get_active_iter (_tmp1_, &_tmp2_);
	iter = _tmp2_;
	if (_tmp3_) {
		GValue val = {0};
		GtkListStore* _tmp4_;
		GtkTreeIter _tmp5_;
		GValue _tmp6_ = {0};
		gint width = 0;
		GValue _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint height = 0;
		GValue _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gdouble* frequencies = NULL;
		gdouble* _tmp13_;
		gint frequencies_length1;
		gint _frequencies_size_;
		gboolean refresh_set = FALSE;
		_tmp4_ = self->priv->resolution_list_store;
		_tmp5_ = iter;
		gtk_tree_model_get_value ((GtkTreeModel*) _tmp4_, &_tmp5_, (gint) DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_MODE, &_tmp6_);
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		val = _tmp6_;
		_tmp7_ = val;
		_tmp8_ = display_monitor_mode_get_width (g_value_get_object (&_tmp7_));
		_tmp9_ = _tmp8_;
		width = _tmp9_;
		_tmp10_ = val;
		_tmp11_ = display_monitor_mode_get_height (g_value_get_object (&_tmp10_));
		_tmp12_ = _tmp11_;
		height = _tmp12_;
		_tmp13_ = g_new0 (gdouble, 0);
		frequencies = _tmp13_;
		frequencies_length1 = 0;
		_frequencies_size_ = frequencies_length1;
		refresh_set = FALSE;
		{
			GeeLinkedList* _mode_list = NULL;
			DisplayVirtualMonitor* _tmp14_;
			GeeLinkedList* _tmp15_;
			gint _mode_size = 0;
			GeeLinkedList* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gint _mode_index = 0;
			_tmp14_ = self->virtual_monitor;
			_tmp15_ = display_virtual_monitor_get_available_modes (_tmp14_);
			_mode_list = _tmp15_;
			_tmp16_ = _mode_list;
			_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
			_tmp18_ = _tmp17_;
			_mode_size = _tmp18_;
			_mode_index = -1;
			while (TRUE) {
				gint _tmp19_;
				gint _tmp20_;
				DisplayMonitorMode* mode = NULL;
				GeeLinkedList* _tmp21_;
				gpointer _tmp22_;
				gboolean _tmp23_ = FALSE;
				DisplayMonitorMode* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				DisplayMonitorMode* _tmp30_;
				gdouble _tmp31_;
				gdouble _tmp32_;
				gdouble* _tmp33_;
				gint _tmp33__length1;
				gboolean freq_already_added = FALSE;
				gdouble* _tmp34_;
				gint _tmp34__length1;
				DisplayMonitorMode* _tmp38_;
				gdouble _tmp39_;
				gdouble _tmp40_;
				gchar* freq_name = NULL;
				DisplayMonitorMode* _tmp41_;
				gdouble _tmp42_;
				gdouble _tmp43_;
				gchar* _tmp44_;
				GtkListStore* _tmp45_;
				GtkTreeIter _tmp46_ = {0};
				GtkListStore* _tmp47_;
				GtkTreeIter _tmp48_;
				const gchar* _tmp49_;
				DisplayMonitorMode* _tmp50_;
				gint _tmp51_;
				DisplayMonitorMode* _tmp52_;
				gboolean _tmp53_;
				gboolean _tmp54_;
				_mode_index = _mode_index + 1;
				_tmp19_ = _mode_index;
				_tmp20_ = _mode_size;
				if (!(_tmp19_ < _tmp20_)) {
					break;
				}
				_tmp21_ = _mode_list;
				_tmp22_ = gee_abstract_list_get ((GeeAbstractList*) _tmp21_, _mode_index);
				mode = (DisplayMonitorMode*) _tmp22_;
				_tmp24_ = mode;
				_tmp25_ = display_monitor_mode_get_width (_tmp24_);
				_tmp26_ = _tmp25_;
				if (_tmp26_ != width) {
					_tmp23_ = TRUE;
				} else {
					DisplayMonitorMode* _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					_tmp27_ = mode;
					_tmp28_ = display_monitor_mode_get_height (_tmp27_);
					_tmp29_ = _tmp28_;
					_tmp23_ = _tmp29_ != height;
				}
				if (_tmp23_) {
					_g_object_unref0 (mode);
					continue;
				}
				_tmp30_ = mode;
				_tmp31_ = display_monitor_mode_get_frequency (_tmp30_);
				_tmp32_ = _tmp31_;
				_tmp33_ = frequencies;
				_tmp33__length1 = frequencies_length1;
				if (_vala_double_array_contains (_tmp33_, _tmp33__length1, _tmp32_)) {
					_g_object_unref0 (mode);
					continue;
				}
				freq_already_added = FALSE;
				_tmp34_ = frequencies;
				_tmp34__length1 = frequencies_length1;
				{
					gdouble* freq_collection = NULL;
					gint freq_collection_length1 = 0;
					gint _freq_collection_size_ = 0;
					gint freq_it = 0;
					freq_collection = _tmp34_;
					freq_collection_length1 = _tmp34__length1;
					for (freq_it = 0; freq_it < freq_collection_length1; freq_it = freq_it + 1) {
						gdouble freq = 0.0;
						freq = freq_collection[freq_it];
						{
							DisplayMonitorMode* _tmp35_;
							gdouble _tmp36_;
							gdouble _tmp37_;
							_tmp35_ = mode;
							_tmp36_ = display_monitor_mode_get_frequency (_tmp35_);
							_tmp37_ = _tmp36_;
							if (fabs (_tmp37_ - freq) < ((gdouble) 1)) {
								freq_already_added = TRUE;
								break;
							}
						}
					}
				}
				if (freq_already_added) {
					_g_object_unref0 (mode);
					continue;
				}
				_tmp38_ = mode;
				_tmp39_ = display_monitor_mode_get_frequency (_tmp38_);
				_tmp40_ = _tmp39_;
				_vala_array_add4 (&frequencies, &frequencies_length1, &_frequencies_size_, _tmp40_);
				_tmp41_ = mode;
				_tmp42_ = display_monitor_mode_get_frequency (_tmp41_);
				_tmp43_ = _tmp42_;
				_tmp44_ = g_strdup_printf (_ ("%g Hz"), (gdouble) roundf ((gfloat) _tmp43_));
				freq_name = _tmp44_;
				_tmp45_ = self->priv->refresh_list_store;
				gtk_list_store_append (_tmp45_, &_tmp46_);
				iter = _tmp46_;
				_tmp47_ = self->priv->refresh_list_store;
				_tmp48_ = iter;
				_tmp49_ = freq_name;
				_tmp50_ = mode;
				gtk_list_store_set (_tmp47_, &_tmp48_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME, _tmp49_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_MODE, _tmp50_, -1);
				_tmp51_ = added;
				added = _tmp51_ + 1;
				_tmp52_ = mode;
				_tmp53_ = display_monitor_mode_get_is_current (_tmp52_);
				_tmp54_ = _tmp53_;
				if (_tmp54_) {
					GtkComboBox* _tmp55_;
					GtkTreeIter _tmp56_;
					_tmp55_ = self->priv->refresh_combobox;
					_tmp56_ = iter;
					gtk_combo_box_set_active_iter (_tmp55_, &_tmp56_);
					refresh_set = TRUE;
				}
				_g_free0 (freq_name);
				_g_object_unref0 (mode);
			}
			_g_object_unref0 (_mode_list);
		}
		frequencies = (g_free (frequencies), NULL);
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	}
	_tmp57_ = self->priv->refresh_combobox;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp57_, added > 1);
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		DisplayDisplayWidget* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->mode);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static gboolean
____lambda14_ (Block5Data* _data5_,
               GtkTreeModel* model,
               GtkTreePath* path,
               GtkTreeIter* iter)
{
	DisplayDisplayWidget* self;
	GValue val = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GValue _tmp2_ = {0};
	GValue _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	DisplayMonitorMode* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gboolean result = FALSE;
	self = _data5_->self;
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = self->priv->resolution_list_store;
	_tmp1_ = *iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp0_, &_tmp1_, (gint) DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_MODE, &_tmp2_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp2_;
	_tmp3_ = val;
	_tmp4_ = display_monitor_mode_get_id (g_value_get_object (&_tmp3_));
	_tmp5_ = _tmp4_;
	_tmp6_ = _data5_->mode;
	_tmp7_ = display_monitor_mode_get_id (_tmp6_);
	_tmp8_ = _tmp7_;
	if (g_strcmp0 (_tmp5_, _tmp8_) == 0) {
		GtkComboBox* _tmp9_;
		GtkTreeIter _tmp10_;
		_tmp9_ = self->priv->resolution_combobox;
		_tmp10_ = *iter;
		gtk_combo_box_set_active_iter (_tmp9_, &_tmp10_);
		result = TRUE;
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		return result;
	}
	result = FALSE;
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	return result;
}

static gboolean
_____lambda14__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                            GtkTreePath* path,
                                            GtkTreeIter* iter,
                                            gpointer self)
{
	gboolean result;
	result = ____lambda14_ (self, model, path, iter);
	return result;
}

static void
display_display_widget_on_monitor_modes_changed (DisplayDisplayWidget* self)
{
	g_return_if_fail (self != NULL);
	{
		GeeLinkedList* _mode_list = NULL;
		DisplayVirtualMonitor* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _mode_index = 0;
		_tmp0_ = self->virtual_monitor;
		_tmp1_ = display_virtual_monitor_get_available_modes (_tmp0_);
		_mode_list = _tmp1_;
		_tmp2_ = _mode_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_mode_size = _tmp4_;
		_mode_index = -1;
		while (TRUE) {
			Block5Data* _data5_;
			gint _tmp5_;
			gint _tmp6_;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			DisplayMonitorMode* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
			GtkListStore* _tmp12_;
			_data5_ = g_slice_new0 (Block5Data);
			_data5_->_ref_count_ = 1;
			_data5_->self = g_object_ref (self);
			_mode_index = _mode_index + 1;
			_tmp5_ = _mode_index;
			_tmp6_ = _mode_size;
			if (!(_tmp5_ < _tmp6_)) {
				block5_data_unref (_data5_);
				_data5_ = NULL;
				break;
			}
			_tmp7_ = _mode_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _mode_index);
			_data5_->mode = (DisplayMonitorMode*) _tmp8_;
			_tmp9_ = _data5_->mode;
			_tmp10_ = display_monitor_mode_get_is_current (_tmp9_);
			_tmp11_ = _tmp10_;
			if (!_tmp11_) {
				block5_data_unref (_data5_);
				_data5_ = NULL;
				continue;
			}
			_tmp12_ = self->priv->resolution_list_store;
			gtk_tree_model_foreach ((GtkTreeModel*) _tmp12_, _____lambda14__gtk_tree_model_foreach_func, _data5_);
			block5_data_unref (_data5_);
			_data5_ = NULL;
		}
		_g_object_unref0 (_mode_list);
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		DisplayDisplayWidget* self;
		self = _data6_->self;
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static gboolean
__lambda13_ (Block6Data* _data6_,
             GtkTreeModel* model,
             GtkTreePath* path,
             GtkTreeIter* iter)
{
	DisplayDisplayWidget* self;
	GValue val = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GValue _tmp2_ = {0};
	DisplayTransform iter_transform = 0;
	GValue _tmp3_;
	DisplayTransform _tmp4_;
	gboolean result = FALSE;
	self = _data6_->self;
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = self->priv->rotation_list_store;
	_tmp1_ = *iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp0_, &_tmp1_, (gint) DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE, &_tmp2_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp2_;
	_tmp3_ = val;
	iter_transform = (DisplayTransform) g_value_get_int (&_tmp3_);
	_tmp4_ = iter_transform;
	if (_tmp4_ == _data6_->transform) {
		GtkComboBox* _tmp5_;
		GtkTreeIter _tmp6_;
		_tmp5_ = self->priv->rotation_combobox;
		_tmp6_ = *iter;
		gtk_combo_box_set_active_iter (_tmp5_, &_tmp6_);
		result = TRUE;
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		return result;
	}
	result = FALSE;
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	return result;
}

static gboolean
___lambda13__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                          GtkTreePath* path,
                                          GtkTreeIter* iter,
                                          gpointer self)
{
	gboolean result;
	result = __lambda13_ (self, model, path, iter);
	return result;
}

static void
display_display_widget_on_vm_transform_changed (DisplayDisplayWidget* self)
{
	Block6Data* _data6_;
	DisplayVirtualMonitor* _tmp0_;
	DisplayTransform _tmp1_;
	DisplayTransform _tmp2_;
	GtkListStore* _tmp3_;
	g_return_if_fail (self != NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_tmp0_ = self->virtual_monitor;
	_tmp1_ = display_virtual_monitor_get_transform (_tmp0_);
	_tmp2_ = _tmp1_;
	_data6_->transform = _tmp2_;
	_tmp3_ = self->priv->rotation_list_store;
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp3_, ___lambda13__gtk_tree_model_foreach_func, _data6_);
	block6_data_unref (_data6_);
	_data6_ = NULL;
}

static gboolean
display_display_widget_real_button_press_event (GtkWidget* base,
                                                GdkEventButton* event)
{
	DisplayDisplayWidget * self;
	gboolean _tmp0_;
	gboolean result = FALSE;
	self = (DisplayDisplayWidget*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->_only_display;
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	self->priv->start_x = event->x_root;
	self->priv->start_y = event->y_root;
	self->priv->holding = TRUE;
	result = FALSE;
	return result;
}

static gboolean
display_display_widget_real_button_release_event (GtkWidget* base,
                                                  GdkEventButton* event)
{
	DisplayDisplayWidget * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
	gint old_delta_x = 0;
	gint _tmp5_;
	gint old_delta_y = 0;
	gint _tmp6_;
	gboolean result = FALSE;
	self = (DisplayDisplayWidget*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	self->priv->holding = FALSE;
	_tmp2_ = self->priv->_delta_x;
	if (_tmp2_ == 0) {
		gint _tmp3_;
		_tmp3_ = self->priv->_delta_y;
		_tmp1_ = _tmp3_ == 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp4_;
		_tmp4_ = self->priv->_only_display;
		_tmp0_ = _tmp4_;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = self->priv->_delta_x;
	old_delta_x = _tmp5_;
	_tmp6_ = self->priv->_delta_y;
	old_delta_y = _tmp6_;
	display_display_widget_set_delta_x (self, 0);
	display_display_widget_set_delta_y (self, 0);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_END_GRAB_SIGNAL], 0, old_delta_x, old_delta_y);
	result = FALSE;
	return result;
}

static gboolean
display_display_widget_real_motion_notify_event (GtkWidget* base,
                                                 GdkEventMotion* event)
{
	DisplayDisplayWidget * self;
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	self = (DisplayDisplayWidget*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (self->priv->holding) {
		gboolean _tmp1_;
		_tmp1_ = self->priv->_only_display;
		_tmp0_ = !_tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_MOVE_DISPLAY_SIGNAL], 0, event->x_root - self->priv->start_x, event->y_root - self->priv->start_y);
	}
	result = FALSE;
	return result;
}

void
display_display_widget_set_primary (DisplayDisplayWidget* self,
                                    gboolean is_primary)
{
	GtkSwitch* _tmp8_;
	g_return_if_fail (self != NULL);
	if (is_primary) {
		GtkButton* _tmp0_;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		GtkButton* _tmp3_;
		_tmp0_ = self->priv->_primary_image;
		_tmp1_ = gtk_button_get_image (_tmp0_);
		_tmp2_ = _tmp1_;
		g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_image_get_type (), GtkImage), "icon-name", "starred-symbolic", NULL);
		_tmp3_ = self->priv->_primary_image;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _ ("Is the primary display"));
	} else {
		GtkButton* _tmp4_;
		GtkWidget* _tmp5_;
		GtkWidget* _tmp6_;
		GtkButton* _tmp7_;
		_tmp4_ = self->priv->_primary_image;
		_tmp5_ = gtk_button_get_image (_tmp4_);
		_tmp6_ = _tmp5_;
		g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_image_get_type (), GtkImage), "icon-name", "non-starred-symbolic", NULL);
		_tmp7_ = self->priv->_primary_image;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, _ ("Set as primary display"));
	}
	_tmp8_ = self->priv->use_switch;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, !is_primary);
}

static void
display_display_widget_real_get_preferred_width (GtkWidget* base,
                                                 gint* minimum_width,
                                                 gint* natural_width)
{
	DisplayDisplayWidget * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	self = (DisplayDisplayWidget*) base;
	_vala_minimum_width = (gint) (self->priv->real_width * self->window_ratio);
	_vala_natural_width = _vala_minimum_width;
	if (minimum_width) {
		*minimum_width = _vala_minimum_width;
	}
	if (natural_width) {
		*natural_width = _vala_natural_width;
	}
}

static void
display_display_widget_real_get_preferred_height (GtkWidget* base,
                                                  gint* minimum_height,
                                                  gint* natural_height)
{
	DisplayDisplayWidget * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	self = (DisplayDisplayWidget*) base;
	_vala_minimum_height = (gint) (self->priv->real_height * self->window_ratio);
	_vala_natural_height = _vala_minimum_height;
	if (minimum_height) {
		*minimum_height = _vala_minimum_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}

void
display_display_widget_get_geometry (DisplayDisplayWidget* self,
                                     gint* x,
                                     gint* y,
                                     gint* width,
                                     gint* height)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
	DisplayVirtualMonitor* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	DisplayVirtualMonitor* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->virtual_monitor;
	_tmp1_ = display_virtual_monitor_get_x (_tmp0_);
	_tmp2_ = _tmp1_;
	_vala_x = _tmp2_;
	_tmp3_ = self->virtual_monitor;
	_tmp4_ = display_virtual_monitor_get_y (_tmp3_);
	_tmp5_ = _tmp4_;
	_vala_y = _tmp5_;
	_vala_width = self->priv->real_width;
	_vala_height = self->priv->real_height;
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
	if (width) {
		*width = _vala_width;
	}
	if (height) {
		*height = _vala_height;
	}
}

void
display_display_widget_set_geometry (DisplayDisplayWidget* self,
                                     gint x,
                                     gint y,
                                     gint width,
                                     gint height)
{
	DisplayVirtualMonitor* _tmp0_;
	DisplayVirtualMonitor* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->virtual_monitor;
	display_virtual_monitor_set_x (_tmp0_, x);
	_tmp1_ = self->virtual_monitor;
	display_virtual_monitor_set_y (_tmp1_, y);
	self->priv->real_width = width;
	self->priv->real_height = height;
}

gboolean
display_display_widget_equals (DisplayDisplayWidget* self,
                               DisplayDisplayWidget* sibling)
{
	DisplayVirtualMonitor* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	DisplayVirtualMonitor* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (sibling != NULL, FALSE);
	_tmp0_ = self->virtual_monitor;
	_tmp1_ = display_virtual_monitor_get_id (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = sibling->virtual_monitor;
	_tmp5_ = display_virtual_monitor_get_id (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strcmp0 (_tmp3_, _tmp7_) == 0;
	_g_free0 (_tmp7_);
	_g_free0 (_tmp3_);
	result = _tmp8_;
	return result;
}

gint
display_display_widget_get_delta_x (DisplayDisplayWidget* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_delta_x;
	return result;
}

void
display_display_widget_set_delta_x (DisplayDisplayWidget* self,
                                    gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = display_display_widget_get_delta_x (self);
	if (old_value != value) {
		self->priv->_delta_x = value;
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY]);
	}
}

gint
display_display_widget_get_delta_y (DisplayDisplayWidget* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_delta_y;
	return result;
}

void
display_display_widget_set_delta_y (DisplayDisplayWidget* self,
                                    gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = display_display_widget_get_delta_y (self);
	if (old_value != value) {
		self->priv->_delta_y = value;
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY]);
	}
}

gboolean
display_display_widget_get_only_display (DisplayDisplayWidget* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_only_display;
	return result;
}

void
display_display_widget_set_only_display (DisplayDisplayWidget* self,
                                         gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = display_display_widget_get_only_display (self);
	if (old_value != value) {
		self->priv->_only_display = value;
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY]);
	}
}

GtkButton*
display_display_widget_get_primary_image (DisplayDisplayWidget* self)
{
	GtkButton* result;
	GtkButton* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_primary_image;
	result = _tmp0_;
	return result;
}

static void
display_display_widget_set_primary_image (DisplayDisplayWidget* self,
                                          GtkButton* value)
{
	GtkButton* old_value;
	g_return_if_fail (self != NULL);
	old_value = display_display_widget_get_primary_image (self);
	if (old_value != value) {
		GtkButton* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_primary_image);
		self->priv->_primary_image = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY]);
	}
}

GtkMenuButton*
display_display_widget_get_toggle_settings (DisplayDisplayWidget* self)
{
	GtkMenuButton* result;
	GtkMenuButton* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_toggle_settings;
	result = _tmp0_;
	return result;
}

static void
display_display_widget_set_toggle_settings (DisplayDisplayWidget* self,
                                            GtkMenuButton* value)
{
	GtkMenuButton* old_value;
	g_return_if_fail (self != NULL);
	old_value = display_display_widget_get_toggle_settings (self);
	if (old_value != value) {
		GtkMenuButton* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_toggle_settings);
		self->priv->_toggle_settings = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY]);
	}
}

static void
g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__DOUBLE_DOUBLE) (gpointer data1, gdouble arg_1, gdouble arg_2, gpointer data2);
	register GMarshalFunc_VOID__DOUBLE_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__DOUBLE_DOUBLE) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_double (param_values + 1), g_value_get_double (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
}

static void
display_display_widget_class_init (DisplayDisplayWidgetClass * klass,
                                   gpointer klass_data)
{
	display_display_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DisplayDisplayWidget_private_offset);
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) display_display_widget_real_button_press_event;
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) display_display_widget_real_button_release_event;
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) display_display_widget_real_motion_notify_event;
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) display_display_widget_real_get_preferred_width;
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) display_display_widget_real_get_preferred_height;
	G_OBJECT_CLASS (klass)->get_property = _vala_display_display_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_display_display_widget_set_property;
	G_OBJECT_CLASS (klass)->finalize = display_display_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY] = g_param_spec_int ("delta-x", "delta-x", "delta-x", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY] = g_param_spec_int ("delta-y", "delta-y", "delta-y", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY] = g_param_spec_boolean ("only-display", "only-display", "only-display", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY] = g_param_spec_object ("primary-image", "primary-image", "primary-image", gtk_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY] = g_param_spec_object ("toggle-settings", "toggle-settings", "toggle-settings", gtk_menu_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_SET_AS_PRIMARY_SIGNAL] = g_signal_new ("set-as-primary", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_MOVE_DISPLAY_SIGNAL] = g_signal_new ("move-display", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE, G_TYPE_NONE, 2, G_TYPE_DOUBLE, G_TYPE_DOUBLE);
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_END_GRAB_SIGNAL] = g_signal_new ("end-grab", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL] = g_signal_new ("check-position", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL] = g_signal_new ("configuration-changed", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_ACTIVE_CHANGED_SIGNAL] = g_signal_new ("active-changed", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
display_display_widget_instance_init (DisplayDisplayWidget * self,
                                      gpointer klass)
{
	self->priv = display_display_widget_get_instance_private (self);
	self->window_ratio = 1.0;
	self->priv->_delta_x = 0;
	self->priv->_delta_y = 0;
	self->priv->_only_display = FALSE;
	self->priv->start_x = (gdouble) 0;
	self->priv->start_y = (gdouble) 0;
	self->priv->holding = FALSE;
	self->priv->real_width = 0;
	self->priv->real_height = 0;
}

static void
display_display_widget_finalize (GObject * obj)
{
	DisplayDisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget);
	_g_object_unref0 (self->virtual_monitor);
	_g_object_unref0 (self->display_window);
	_g_object_unref0 (self->priv->_primary_image);
	_g_object_unref0 (self->priv->_toggle_settings);
	_g_object_unref0 (self->priv->use_switch);
	_g_object_unref0 (self->priv->resolution_combobox);
	_g_object_unref0 (self->priv->resolution_list_store);
	_g_object_unref0 (self->priv->rotation_combobox);
	_g_object_unref0 (self->priv->rotation_list_store);
	_g_object_unref0 (self->priv->refresh_combobox);
	_g_object_unref0 (self->priv->refresh_list_store);
	G_OBJECT_CLASS (display_display_widget_parent_class)->finalize (obj);
}

static GType
display_display_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplayWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_display_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayDisplayWidget), 0, (GInstanceInitFunc) display_display_widget_instance_init, NULL };
	GType display_display_widget_type_id;
	display_display_widget_type_id = g_type_register_static (gtk_event_box_get_type (), "DisplayDisplayWidget", &g_define_type_info, 0);
	DisplayDisplayWidget_private_offset = g_type_add_instance_private (display_display_widget_type_id, sizeof (DisplayDisplayWidgetPrivate));
	return display_display_widget_type_id;
}

GType
display_display_widget_get_type (void)
{
	static volatile gsize display_display_widget_type_id__volatile = 0;
	if (g_once_init_enter (&display_display_widget_type_id__volatile)) {
		GType display_display_widget_type_id;
		display_display_widget_type_id = display_display_widget_get_type_once ();
		g_once_init_leave (&display_display_widget_type_id__volatile, display_display_widget_type_id);
	}
	return display_display_widget_type_id__volatile;
}

static void
_vala_display_display_widget_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	DisplayDisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget);
	switch (property_id) {
		case DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY:
		g_value_set_int (value, display_display_widget_get_delta_x (self));
		break;
		case DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY:
		g_value_set_int (value, display_display_widget_get_delta_y (self));
		break;
		case DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY:
		g_value_set_boolean (value, display_display_widget_get_only_display (self));
		break;
		case DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY:
		g_value_set_object (value, display_display_widget_get_primary_image (self));
		break;
		case DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY:
		g_value_set_object (value, display_display_widget_get_toggle_settings (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_display_display_widget_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	DisplayDisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget);
	switch (property_id) {
		case DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY:
		display_display_widget_set_delta_x (self, g_value_get_int (value));
		break;
		case DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY:
		display_display_widget_set_delta_y (self, g_value_get_int (value));
		break;
		case DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY:
		display_display_widget_set_only_display (self, g_value_get_boolean (value));
		break;
		case DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY:
		display_display_widget_set_primary_image (self, g_value_get_object (value));
		break;
		case DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY:
		display_display_widget_set_toggle_settings (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

