/* DisplayWindow.c generated by valac 0.53.1, the Vala compiler
 * generated from DisplayWindow.vala, do not modify */

/*-
 * Copyright (c) 2014-2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "display.h"
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <string.h>

enum  {
	DISPLAY_DISPLAY_WINDOW_0_PROPERTY,
	DISPLAY_DISPLAY_WINDOW_NUM_PROPERTIES
};
static GParamSpec* display_display_window_properties[DISPLAY_DISPLAY_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer display_display_window_parent_class = NULL;

static GObject * display_display_window_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static GType display_display_window_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

DisplayDisplayWindow*
display_display_window_construct (GType object_type,
                                  DisplayVirtualMonitor* virtual_monitor)
{
	DisplayDisplayWindow * self = NULL;
	GtkLabel* label = NULL;
	const gchar* _tmp0_;
	GtkLabel* _tmp1_;
	gint scale_factor = 0;
	GtkStyleContext* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	g_return_val_if_fail (virtual_monitor != NULL, NULL);
	self = (DisplayDisplayWindow*) g_object_new (object_type, NULL);
	_tmp0_ = display_virtual_monitor_get_display_name (virtual_monitor);
	_tmp1_ = (GtkLabel*) gtk_label_new (_tmp0_);
	g_object_ref_sink (_tmp1_);
	label = _tmp1_;
	g_object_set ((GtkWidget*) label, "margin", 12, NULL);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) label);
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
	scale_factor = gtk_style_context_get_scale (_tmp2_);
	_tmp3_ = display_virtual_monitor_get_current_x (virtual_monitor);
	_tmp4_ = _tmp3_;
	_tmp5_ = display_virtual_monitor_get_current_y (virtual_monitor);
	_tmp6_ = _tmp5_;
	gtk_window_move ((GtkWindow*) self, (gint) (_tmp4_ / scale_factor), (gint) (_tmp6_ / scale_factor));
	_g_object_unref0 (label);
	return self;
}

DisplayDisplayWindow*
display_display_window_new (DisplayVirtualMonitor* virtual_monitor)
{
	return display_display_window_construct (DISPLAY_TYPE_DISPLAY_WINDOW, virtual_monitor);
}

static GObject *
display_display_window_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayDisplayWindow * self;
	parent_class = G_OBJECT_CLASS (display_display_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAY_WINDOW, DisplayDisplayWindow);
	gtk_widget_input_shape_combine_region ((GtkWidget*) self, NULL);
	gtk_window_set_accept_focus ((GtkWindow*) self, FALSE);
	gtk_window_set_decorated ((GtkWindow*) self, FALSE);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
	gtk_widget_set_can_focus ((GtkWidget*) self, FALSE);
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, TRUE);
	gtk_window_set_skip_pager_hint ((GtkWindow*) self, TRUE);
	gtk_window_set_type_hint ((GtkWindow*) self, GDK_WINDOW_TYPE_HINT_TOOLTIP);
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	gtk_widget_set_opacity ((GtkWidget*) self, 0.8);
	return obj;
}

static void
display_display_window_class_init (DisplayDisplayWindowClass * klass,
                                   gpointer klass_data)
{
	display_display_window_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = display_display_window_constructor;
}

static void
display_display_window_instance_init (DisplayDisplayWindow * self,
                                      gpointer klass)
{
}

static GType
display_display_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplayWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_display_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayDisplayWindow), 0, (GInstanceInitFunc) display_display_window_instance_init, NULL };
	GType display_display_window_type_id;
	display_display_window_type_id = g_type_register_static (gtk_window_get_type (), "DisplayDisplayWindow", &g_define_type_info, 0);
	return display_display_window_type_id;
}

GType
display_display_window_get_type (void)
{
	static volatile gsize display_display_window_type_id__volatile = 0;
	if (g_once_init_enter (&display_display_window_type_id__volatile)) {
		GType display_display_window_type_id;
		display_display_window_type_id = display_display_window_get_type_once ();
		g_once_init_leave (&display_display_window_type_id__volatile, display_display_window_type_id);
	}
	return display_display_window_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

